﻿Public Class SimpleRTB
    Inherits System.Windows.Forms.RichTextBox

    ' ===============================================================================================
    '  ENABLE DISABLE PAINT
    '  DISABLE ZOOM with CTRL WHEEL
    '  IF FOCUSED then the CTRL WHEEL changes the cursor line instead to scroll
    ' ===============================================================================================
    Friend PaintEventEnabled As Boolean = True

    Private Const MK_CONTROL As Int32 = &H8
    Private Const WM_MOUSEWHEEL As Int32 = &H20A

    <DebuggerStepThrough()>
    Protected Overrides Sub WndProc(ByRef m As Message)
        Const WM_PAINT As Int32 = &HF
        If m.Msg = WM_PAINT AndAlso Not PaintEventEnabled Then
            m.Result = IntPtr.Zero
        ElseIf m.Msg = WM_MOUSEWHEEL Then
            If (m.WParam.ToInt32 And MK_CONTROL) = MK_CONTROL Then
                m.WParam = IntPtr.Zero
                m.Result = IntPtr.Zero
            ElseIf Me.Focused Then
                ChangeCursorLine(m.WParam.ToInt32 \ 65536 \ 120)
                m.WParam = IntPtr.Zero
                m.Result = IntPtr.Zero
            Else
                MyBase.WndProc(m)
            End If
        Else
            MyBase.WndProc(m)
        End If
    End Sub

    ' ===============================================================================================
    '   Change the cursor line instead to scroll
    ' ===============================================================================================
    Private Sub ChangeCursorLine(ByVal delta As Int32)
        Dim line As Int32 = Me.GetLineFromCharIndex(Me.SelectionStart)
        line -= delta
        If line >= Me.Lines.Length Then line = Me.Lines.Length - 1
        If line < 0 Then line = 0
        Me.Select(Me.GetFirstCharIndexFromLine(line), 0)
    End Sub

    ' ===============================================================================================
    '   SAVE/RESTORE the SCROLL POS
    ' ===============================================================================================
    Private Declare Auto Function RtfScroll _
                Lib "user32.dll" Alias "SendMessage" (ByVal hWnd As IntPtr,
                                                      ByVal Msg As Integer,
                                                      ByVal wParam As IntPtr,
                                                      ByRef lParam As System.Drawing.Point) As Integer

    Private Declare Function LockWindowUpdate Lib "user32" (ByVal hWnd As Integer) As Integer

    Private Const WM_USER As Int32 = &H400
    Private Const EM_GETSCROLLPOS As Int32 = WM_USER + 221
    Private Const EM_SETSCROLLPOS As Int32 = WM_USER + 222

    Private TextBoxOriginalScroll As Int32

    Private pt As New System.Drawing.Point()
    Friend Sub SaveScroll()
        If Me.Focused Then
            LockWindowUpdate(Me.Handle.ToInt32)
            TextBoxOriginalScroll = Me.SelectionStart
        Else
            RtfScroll(Me.Handle, EM_GETSCROLLPOS, IntPtr.Zero, pt)
        End If
    End Sub
    Friend Sub RestoreScroll()
        If Me.Focused Then
            Me.SelectionStart = TextBoxOriginalScroll
            Me.ScrollToCaret()
        Else
            RtfScroll(Me.Handle, EM_SETSCROLLPOS, IntPtr.Zero, pt)
        End If
        LockWindowUpdate(0)
    End Sub


    ' ===============================================================================================
    '   SUPPRESS SOUNDS
    ' ===============================================================================================
    Private Sub Me_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        ' -------------------------------------------------- suppress RTB sounds
        RichTextBox_SuppressSounds(sender, e)
    End Sub


    'Private Sub PrintTextBox_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles PrintTextBox.KeyDown
    '    ' TODO COPY FROM TEXT BOX

    '    ' ------------------------------------------------------------- CUT / COPY / PASTE / UNDO / REDO
    '    'If My.Computer.Keyboard.CtrlKeyDown Then
    '    '    e.SuppressKeyPress = True
    '    '    e.Handled = True
    '    '    Select Case e.KeyCode
    '    '        'Case Keys.F : Editor_Find()
    '    '        'Case Keys.R : Editor_FindReplace()
    '    '        Case Keys.X : RTB.ExecCut()
    '    '        Case Keys.C : RTB.ExecCopy()
    '    '        Case Keys.V : RTB.ExecPaste()
    '    '        Case Keys.Z : RTB.ExecUndo()
    '    '        Case Keys.Y : RTB.ExecRedo()
    '    '        Case Keys.Space : RTB.CompleteKeyword()
    '    '        Case Else
    '    '            e.Handled = False
    '    '            e.SuppressKeyPress = False
    '    '    End Select
    '    'End If

    '    'Dim data As IDataObject
    '    'data = New DataObject(DataFormats.Text, PrintTextBox.SelectedText.Replace(vbLf, vbCrLf))
    '    'Clipboard.SetDataObject(data, True)
    'End Sub

    'Protected Overrides Function IsInputKey(ByVal keyData As Keys) As Boolean
    '    Select Case (keyData)
    '        Case Keys.Right, Keys.Left, Keys.Up, Keys.Down
    '            Return True
    '        Case Keys.Shift Or Keys.Right, Keys.Shift Or Keys.Left, Keys.Shift Or Keys.Up, Keys.Shift Or Keys.Down
    '            Return True
    '    End Select
    '    Return MyBase.IsInputKey(keyData)
    'End Function

    'Protected Overrides Sub OnKeyDown(ByVal e As KeyEventArgs)
    '    MyBase.OnKeyDown(e)
    '    Select Case (e.KeyCode)
    '        Case Keys.Left, Keys.Right, Keys.Up, Keys.Down
    '            If e.Shift Then

    '            Else

    '            End If
    '    End Select
    'End Sub




End Class
