﻿
Imports System.Buffers
Imports System.Reflection
Imports System.Windows.Forms.VisualStyles.VisualStyleElement.ToolBar

Partial Class Form1
    Inherits System.Windows.Forms.Form

    ' ===================================================================================================
    '  INIT BUTTONS
    ' ===================================================================================================

    Private OldCode As String = ""

    Private OldFunctionNamesLength As Int32 = 0

    Friend Sub InitButtons(code As String)
        ' ----------------------------------------------- test if code is changed
        If code = OldCode Then Return
        OldCode = code
        ' -----------------------------------------------

        ' TODO - More than 16 buttons - No edit block names - Added this test
        ReadFunctionNames(code)
        If FunctionNames.Length <> OldFunctionNamesLength Then
            OldFunctionNamesLength = FunctionNames.Length
            SetInitialButtonNamesColorsAndPositions()
        End If

        ' -------------------------------------------- OLD VERSION
        'SetInitialButtonNamesColorsAndPositions()
        'ResetButtonIdentifiersAndSlots()
        'ReadFunctionNames(code)
        ' ---------------------------------------------------------


        For i As Int32 = 0 To FunctionNames.Length - 1
            Dim s As String = FunctionNames(i)
            If s.StartsWith("_") Then
                s = "_" + FunctionNames(i).Replace("_", " ")
            Else
                s = FunctionNames(i).Replace("_", " ")
            End If
            SetButton((i + 1).ToString, s, 0)
        Next
    End Sub

    Private FunctionNames(-1) As String
    Private Sub ReadFunctionNames(ByVal code As String)
        ReDim FunctionNames(-1)
        Dim bc() As String = code.Split(CChar(vbLf))
        For n As Int32 = 0 To bc.Length - 1
            If bc(n).StartsWith("function ") Then
                Dim str As String = bc(n).Substring(9)
                Dim n2 As Int32 = str.IndexOf("(")
                If n2 > 0 Then
                    str = str.Substring(0, n2 + 1)
                    If Not str.StartsWith("mathIsPrime(") And
                       Not str.StartsWith("mathMean(") And
                       Not str.StartsWith("mathMedian(") And
                       Not str.StartsWith("mathModes(") And
                       Not str.StartsWith("mathStandardDeviation(") And
                       Not str.StartsWith("mathRandomList(") And
                       Not str.StartsWith("mathRandomInt(") And
                       Not str.StartsWith("colourRandom(") And
                       Not str.StartsWith("textCount(") And
                       Not str.StartsWith("textReplace(") Then
                        str = str.Substring(0, n2)
                        ReDim Preserve FunctionNames(FunctionNames.Length)
                        FunctionNames(FunctionNames.Length - 1) = str
                    End If
                End If
            End If
        Next
    End Sub

    Private Sub Buttons_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        Dim ButtonName As String = CType(sender, CheckBox).Name
        ButtonName = ButtonName.Replace("Button_", "")
        ExecuteButton(Val_Int(ButtonName) - 1)
    End Sub

    Private Sub ExecuteButton(index As Int32)
        If Not ButtonEnabled(index) Then Return
        If Not Buttons(index).Visible Then Return
        ' ---------------------------------- a little delay to see the button checked 
        Buttons(index).Checked = True
        Threading.Thread.Sleep(20)
        Buttons(index).Checked = False
        ' -------------------------------------------------------
        Dim s As String = ButtonIdentifiers(index)
        ExecuteFunctionByIdentifier(s)
    End Sub

    Private Sub ExecButtonsFromSlots()
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonSlots(i) >= 0 Then
                Dim NewValue As Single = Slots.ReadSlot_NoNan(ButtonSlots(i))
                If NewValue > 500 And ButtonSlotsOldValues(i) <= 500 Then
                    ExecuteButton(i)
                End If
                ButtonSlotsOldValues(i) = NewValue
            End If
        Next
    End Sub

    ' TODO - EXECUTE FIRST BUTTON
    Friend Function ExecuteFirstButton() As Boolean
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonIdentifiers(i) <> "" Then
                If Buttons(i).Visible Then
                    ExecuteButton(i)
                    Return True
                End If
            End If
        Next
        Return False
    End Function


    ' ===================================================================================================
    '  COMMANDS FROM TEXT SLOT
    ' ===================================================================================================
    Private ExecutingCommand As Boolean = False
    Friend SlotText_Commands As Int32 = -1
    Private Sub ExecCommandsFromTextSlot()
        If SlotText_Commands <= 0 Then Return
        If ExecutingCommand Then Return
        ExecutingCommand = True
        Dim cmd As String = StringSlots.ReadString(SlotText_Commands).ToLower
        If cmd <> "" Then
            If cmd.StartsWith("enablebutton ") Then
                cmd = cmd.ToLower.Replace("enablebutton ", "")
                If cmd <> "" Then
                    Dim i As Int32 = GetButtonByIdentifierOrIndex(cmd)
                    EnableButton(i - 1)
                End If
            ElseIf cmd.StartsWith("disablebutton ") Then
                cmd = cmd.ToLower.Replace("disablebutton ", "")
                If cmd <> "" Then
                    Dim i As Int32 = GetButtonByIdentifierOrIndex(cmd)
                    DisableButton(i - 1)
                End If
            Else
                Select Case cmd.ToLower
                    Case "run" : StartExecution()
                    Case "stop" : StopExecution()
                    Case "pause" : PauseExecution()
                    Case "step" : StepExecution()
                    Case "continue" : ContinueExecution()
                    Case Else
                        cmd = FindButtonIdentifierCaseInsensitive(cmd)
                        If cmd <> "" Then ExecuteFunctionByIdentifier(cmd)
                End Select
            End If
            StringSlots.WriteString(SlotText_Commands, "")
        End If
        ExecutingCommand = False
    End Sub

    Private Function FindButtonIdentifierCaseInsensitive(ByVal IdString As String) As String
        Dim id As String
        IdString = NormalizeIdentifier(IdString.Trim)
        For i As Int32 = 0 To NBUTTONS - 1
            id = ButtonIdentifiers(i)
            id = NormalizeIdentifier(id)
            If id = IdString Then
                Return ButtonIdentifiers(i)
            End If
        Next
        Return ""
    End Function

    ' TODO -- Normalize OK ?
    Private Function NormalizeIdentifier(ByVal IdString As String) As String
        IdString = IdString.Replace(vbCrLf, "__")
        IdString = IdString.Replace("__", "_")
        IdString = IdString.Replace(" ", "_")
        IdString = IdString.Trim({"_"c})
        Return IdString.ToLower
    End Function


    ' ===================================================================================================
    '  BUTTON FUNCTIONS
    ' ===================================================================================================
    Friend Const NBUTTONS As Int32 = 128
    Private Const ButtonsWidth As Int32 = 162
    Private Const ButtonsHeight As Int32 = 46
    Private Const ButtonsLeft As Int32 = 9
    Private Const ButtonsTop As Int32 = 19

    Friend ReadOnly Buttons(NBUTTONS - 1) As CheckBox
    Private ReadOnly ButtonEnabled(NBUTTONS - 1) As Boolean
    Private ReadOnly ButtonIdentifiers(NBUTTONS - 1) As String
    Private ReadOnly ButtonDeclarationLines(NBUTTONS - 1) As Int32
    Private ReadOnly ButtonSlots(NBUTTONS - 1) As Int32
    Private ReadOnly ButtonSlotsOldValues(NBUTTONS - 1) As Single
    Private ReadOnly ButtonFlashingFrequency(NBUTTONS - 1) As Single
    Private ReadOnly ButtonBackColor(NBUTTONS - 1) As Color
    Private ReadOnly ButtonForeColor(NBUTTONS - 1) As Color
    Private ReadOnly ButtonFlashingTimer(NBUTTONS - 1) As Single
    Private ReadOnly ButtonFlashingColor1(NBUTTONS - 1) As Color
    Private ReadOnly ButtonFlashingColor2(NBUTTONS - 1) As Color

    Private Sub SetButtonsToFront()
        For i As Int32 = 0 To NBUTTONS - 1
            Buttons(i).BringToFront()
        Next
    End Sub

    Private Sub Buttons_Create()
        For i As Int32 = 0 To NBUTTONS - 1
            Buttons(i) = New CheckBox
            With Buttons(i)
                .Appearance = Appearance.Button
                .FlatStyle = FlatStyle.Flat
                .FlatAppearance.BorderColor = Color.DarkGray
                .FlatAppearance.BorderSize = 2
                .FlatAppearance.CheckedBackColor = Color.OldLace
                .Font = New Font("Tahoma", 8.25)
                .Size = New Size(ButtonsWidth, ButtonsHeight)
                .Name = "Button_" + (i + 1).ToString
                .TextAlign = ContentAlignment.MiddleCenter
                .UseVisualStyleBackColor = False
                .Visible = False
            End With
            AddHandler Buttons(i).Click, AddressOf Buttons_Click
            GroupBox1.Controls.AddRange(Buttons)
        Next
    End Sub

    Friend Sub SetInitialButtonNamesColorsAndPositions()
        OldCode = ""
        ' ------------------------------------------------------------------------ set name and colors
        For i As Int32 = 0 To NBUTTONS - 1
            With Buttons(i)
                .Text = ""
                .BackColor = Color.OldLace
                .ForeColor = Color.Black
                ButtonBackColor(i) = .BackColor
                ButtonForeColor(i) = .ForeColor
                EnableButton(i)
                ButtonFlashingFrequency(i) = 0
                .FlatAppearance.BorderSize = 1
                .FlatAppearance.BorderColor = Color.Gray
            End With
        Next
        ' ------------------------------------------------------------------------ set position
        Dim x As Int32 = ButtonsLeft
        Dim y As Int32 = ButtonsTop
        Dim dw As Int32 = ButtonsWidth + 2
        Dim dh As Int32 = ButtonsHeight
        Dim row As Int32
        Dim col As Int32
        For i As Int32 = 0 To NBUTTONS - 1
            With Buttons(i)
                row = i Mod 16
                col = i \ 16
                .Left = x + dw * col
                .Top = y + dh * row
            End With
        Next
        SetVisibleButtons()
    End Sub

    Private ButtonColumns As Int32
    Private OldButtonColumns As Int32

    Private Sub SetVisibleButtons()
        If Not EventsAreEnabled Then Return
        ' ---------------------------------------------------------------
        Dim b As CheckBox
        Dim ypos As Int32
        Dim column As Int32
        If Running Then
            ypos = Chk_ControlsRun.Top - 2
        Else
            ypos = Chk_ControlsUndo.Top - 2
        End If
        ButtonColumns = 0
        For i As Int32 = 0 To NBUTTONS - 1
            b = Buttons(i)
            If b.Text <> Nothing And Not b.Text.StartsWith("_") Then
                If i > 15 Then
                    b.Visible = b.Bottom < GroupBox1.ClientSize.Height - 4
                Else
                    b.Visible = b.Bottom < ypos
                End If
                SetButtonFontSize(b)

                column = i \ 16
                If column > ButtonColumns Then
                    ButtonColumns = column
                End If
            Else
                b.Visible = False
            End If
        Next
        If ButtonColumns <> OldButtonColumns Then
            OldButtonColumns = ButtonColumns
            ' ---------------------------------------------------------------
            ResizeControlAndProgramPanels()
            ' ---------------------------------------------------------------
            Me.MinimumSize = New Size(GroupBox1.Left + 16, Buttons(0).Height * 7)
            ' ---------------------------------------------------------------
            ShowHideTextAndTools()
        End If
    End Sub

    Friend Sub EnableAllButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            EnableButton(i)
        Next
    End Sub
    Friend Sub DisableAllButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            DisableButton(i)
        Next
    End Sub
    Friend Sub EnableButton(ByVal n As Int32)
        ButtonEnabled(n) = True
        With Buttons(n)
            .Enabled = True
            .ForeColor = ButtonForeColor(n)
            .BackColor = ButtonBackColor(n)
            .FlatAppearance.MouseOverBackColor = ModifiedColor(.BackColor, 90)
        End With
    End Sub

    Friend Sub DisableButton(ByVal n As Int32)
        ButtonEnabled(n) = False
        With Buttons(n)
            .Enabled = False
            .ForeColor = Color.FromArgb(80, 80, 80)
            .BackColor = Color.FromArgb(210, 210, 210)
            .FlatAppearance.MouseOverBackColor = Color.FromArgb(200, 200, 200)
        End With
    End Sub

    Friend Sub SetButtonEnableByIdentifierOrIndex(IDstring As String, enable As Boolean)
        Dim ButtonIndex As Int32
        ButtonIndex = GetButtonByIdentifierOrIndex(IDstring)
        If ButtonIndex > 0 And ButtonIndex <= NBUTTONS Then
            If enable Then
                EnableButton(ButtonIndex - 1)
            Else
                DisableButton(ButtonIndex - 1)
            End If
        End If
    End Sub

    Private Sub SetButtonFontSize(ByVal b As CheckBox)
        '
        Dim fontsize As Single = b.Height / 5.0F
        ' --------------------------------------------------------- avoid errors if the form is zero size
        If fontsize = 0 Then fontsize = 9.2
        ' ---------------------------------------------------------
        b.Font = New Font("Tahoma", fontsize * 1.6F)
        Dim pixels As Size = TextRenderer.MeasureText(b.Text, b.Font)
        If b.Text.Contains(vbCrLf) Then
            ' ----------------------------------------------------- font for two lines
            b.Font = New Font("Tahoma", fontsize * 1.1F)
            ' ----------------------------------------------------- try to correct for long names also if containing spaces
            Dim sa() As String = Strings.Split(b.Text, vbCrLf)
            Dim MaxWidth As Int32 = -1
            For i As Int32 = 0 To sa.Length - 1
                pixels = TextRenderer.MeasureText(sa(i), b.Font)
                If pixels.Width > MaxWidth Then
                    MaxWidth = pixels.Width
                End If
            Next
            If MaxWidth >= b.Width - 10 Then
                b.Font = New Font("Tahoma", CSng(fontsize * 1.1F * (b.Width - 10) / MaxWidth))
            End If
        ElseIf pixels.Width >= b.Width - 10 Then
            b.Font = New Font("Tahoma", CSng(fontsize * 1.6F * (b.Width - 20) / pixels.Width))
        End If
    End Sub

    Friend Function ModifiedColor(ByVal c As Color, ByVal delta As Int32) As Color
        Dim r As Int32 = c.R + delta
        Dim g As Int32 = c.G + delta
        Dim b As Int32 = c.B + delta
        If r < 0 Then r = 0
        If g < 0 Then g = 0
        If b < 0 Then b = 0
        If r > 255 Then r = 255
        If g > 255 Then g = 255
        If b > 255 Then b = 255
        Return Color.FromArgb(r, g, b)
    End Function

    Private Sub ResetButtonIdentifiersAndSlots()
        For i As Int32 = 0 To NBUTTONS - 1
            ButtonSlots(i) = -1
            ButtonIdentifiers(i) = ""
        Next
    End Sub

    Private Function GetButtonByIdentifier(ByVal IdString As String) As Int32
        IdString = IdString.ToLower
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonIdentifiers(i).ToLower = IdString Then
                Return i + 1
            End If
        Next
        Return 0
    End Function

    Friend Function GetButtonByIdentifierOrIndex(ByVal IdString As String) As Int32
        IdString = IdString.ToLower
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonIdentifiers(i).ToLower = IdString Then
                Return i + 1
            End If
        Next
        Return Val_Int(IdString)
    End Function

    Private Sub ResizeControlAndProgramPanels()
        GroupBox1.Width = Buttons(ButtonColumns * 16).Right + Buttons(0).Left
        GroupBox_MainArea.Left = GroupBox1.Right + 6

        ' TODO - More than 16 buttons - No edit block names
        'If GroupBox_MainArea.Width <> Me.ClientSize.Width - GroupBox_MainArea.Left - 6 Then
        GroupBox_MainArea.Width = Me.ClientSize.Width - GroupBox_MainArea.Left - 6
        'End If
    End Sub


    ' =============================================================================================
    '   SET BUTTON
    ' =============================================================================================
    Private Sub SetButton(ByVal BtnID As String, ByVal text As String, ByVal line As Int32)

        ' ------------------------------------------------- test if the ID is number or identifier
        Dim IdentifiedByNumber As Boolean = True
        Dim nbutton As Int32 = CInt(Val(BtnID))
        If nbutton = 0 Then
            nbutton = GetButtonByIdentifier(BtnID)
            IdentifiedByNumber = False
        End If
        If nbutton < 1 Or nbutton > NBUTTONS Then Return
        ' -------------------------------------------------
        Dim b As CheckBox
        b = Buttons(nbutton - 1)
        If b Is Nothing Then Return
        If text = Nothing Then
            b.Text = Nothing
            ButtonIdentifiers(nbutton - 1) = ""
            SetVisibleButtons()
            Return
        End If
        Select Case text.ToLower
            Case "enabled"
                EnableButton(nbutton - 1)
                SetVisibleButtons()
            Case "disabled"
                DisableButton(nbutton - 1)
                SetVisibleButtons()
            Case Else
                text = text.Replace("""", "")
                text = text.Replace("  ", vbCrLf)
                If text <> b.Text Then
                    b.Text = text
                    If IdentifiedByNumber Then
                        ButtonDeclarationLines(nbutton - 1) = line
                        ButtonIdentifiers(nbutton - 1) = text
                        SetVisibleButtons()
                    End If
                    SetButtonFontSize(b)
                    b.Refresh()
                End If
        End Select
    End Sub


    ' =============================================================================================
    '   SET BUTTON COLOR / COLOR-FLASHING
    ' =============================================================================================
    Friend Sub SetButtonColor(IDstring As String, hexcol As String)
        Dim ButtonIndex As Int32
        ButtonIndex = GetButtonByIdentifierOrIndex(IDstring)
        If ButtonIndex > 0 And ButtonIndex <= NBUTTONS Then
            Dim btn As CheckBox = Buttons(ButtonIndex - 1)
            Dim c As Color = System.Drawing.ColorTranslator.FromHtml(hexcol)
            btn.BackColor = c
            ButtonBackColor(ButtonIndex - 1) = c
            CorrectButtonForeColor(btn, ButtonIndex)
            ButtonFlashingFrequency(ButtonIndex - 1) = 0
        End If
    End Sub

    Friend Sub SetButtonColorsFlashing(IDstring As String, hexcol1 As String, hexcol2 As String, speed As Int32)
        Dim ButtonIndex As Int32
        ButtonIndex = GetButtonByIdentifierOrIndex(IDstring)
        If ButtonIndex > 0 And ButtonIndex <= NBUTTONS Then
            Dim btn As CheckBox = Buttons(ButtonIndex - 1)
            '
            Dim freq As Single = speed
            Select Case freq
                Case 0 : freq = 4
                Case 1 : freq = 1
                Case 2 : freq = 1.5
                Case 3 : freq = 2
                Case 4 : freq = 3
                Case 5 : freq = 4.5
                Case 6 : freq = 6.5
                Case 7 : freq = 9
                Case 8 : freq = 13.5
                Case 9 : freq = 20
            End Select
            ButtonFlashingFrequency(ButtonIndex - 1) = freq
            ButtonFlashingTimer(ButtonIndex - 1) = 0
            '
            ButtonFlashingColor1(ButtonIndex - 1) = System.Drawing.ColorTranslator.FromHtml(hexcol1)
            ButtonFlashingColor2(ButtonIndex - 1) = System.Drawing.ColorTranslator.FromHtml(hexcol2)
            btn.BackColor = ButtonFlashingColor2(ButtonIndex)
        End If
    End Sub

    Private Sub CorrectButtonForeColor(ByVal b As CheckBox, ByVal buttonIndexBase1 As Int32)
        If GrayScaleLuminance(b.BackColor) < 145 Then
            b.ForeColor = Color.White
            b.FlatAppearance.MouseOverBackColor = ModifiedColor(b.BackColor, 90)
        Else
            b.ForeColor = Color.Black
            b.FlatAppearance.MouseOverBackColor = ModifiedColor(b.BackColor, -30)
        End If
        ButtonForeColor(buttonIndexBase1 - 1) = b.ForeColor
    End Sub

    Friend Function GrayScaleLuminance(ByVal c As Color) As Byte
        Dim lum As Double = 0.299 * c.R + 0.587 * c.G + 0.114 * c.B
        Return CByte(lum)
    End Function

    Private Sub ExecFlashingButtons()
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonFlashingFrequency(i) > 0 Then
                ButtonFlashingTimer(i) -= Timer50ms.Interval
                If ButtonFlashingTimer(i) <= 0 Then
                    ButtonFlashingTimer(i) = 1000 / ButtonFlashingFrequency(i)
                    Dim b As CheckBox = Buttons(i)
                    If b.BackColor = ButtonFlashingColor1(i) Then
                        b.BackColor = ButtonFlashingColor2(i)
                    Else
                        b.BackColor = ButtonFlashingColor1(i)
                    End If
                    CorrectButtonForeColor(b, i + 1)
                End If
            End If
        Next
    End Sub

    Private Sub AllFlashingButtonsToFirstColor()
        For i As Int32 = 0 To NBUTTONS - 1
            If ButtonFlashingFrequency(i) > 0 Then
                Dim b As CheckBox = Buttons(i)
                b.BackColor = ButtonFlashingColor1(i)
                ButtonBackColor(i) = b.BackColor
                CorrectButtonForeColor(b, i + 1)
            End If
        Next
    End Sub

    ' =============================================================================================
    '   SET BUTTON SLOT / TEXT 
    ' =============================================================================================
    Friend Sub SetButtonSlot(IDstring As String, slot As Int32)
        Dim ButtonIndex As Int32
        ButtonIndex = GetButtonByIdentifierOrIndex(IDstring)
        If ButtonIndex > 0 And ButtonIndex <= NBUTTONS Then
            If slot > 0 And slot < 1000 Then
                Dim btn As CheckBox = Buttons(ButtonIndex - 1)
                ButtonSlots(ButtonIndex - 1) = slot
            End If
        End If
    End Sub

    Friend Sub SetButtonText(IDstring As String, text As String)
        Dim ButtonIndex As Int32
        ButtonIndex = GetButtonByIdentifierOrIndex(IDstring)
        If ButtonIndex > 0 And ButtonIndex <= NBUTTONS Then
            Dim btn As CheckBox = Buttons(ButtonIndex - 1)
            btn.Text = text
        End If
    End Sub




End Class
